Attribute VB_Name = "Printer_tisk_dokumentu"
' By HaCeSOFT
' Pavel Prochazka
' hacesoft@mujmail.cz
' www.prochazka.zde.cz
'
'
' DATE 24_4_2005.18:30
'
'
' TENTO SW je pro nekomercni ucely zdarma!!!


Const PT_LINETO = &H2
Const PT_BEZIERTO = &H4
Const PT_CLOSEFIGURE = &H1
Const DI_APPBANDING = &H1
Const DI_ROPS_READ_DESTINATION = &H2

Const FW_DONTCARE = 0
Const FW_THIN = 100
Const FW_EXTRALIGHT = 200
Const FW_LIGHT = 300
Const FW_NORMAL = 400
Const FW_MEDIUM = 500
Const FW_SEMIBOLD = 600
Const FW_BOLD = 700
Const FW_EXTRABOLD = 800
Const FW_HEAVY = 900
Const FW_BLACK = FW_HEAVY
Const FW_DEMIBOLD = FW_SEMIBOLD
Const FW_REGULAR = FW_NORMAL
Const FW_ULTRABOLD = FW_EXTRABOLD
Const FW_ULTRALIGHT = FW_EXTRALIGHT
'used with fdwCharSet
Const ANSI_CHARSET = 0
Const DEFAULT_CHARSET = 1
Const SYMBOL_CHARSET = 2
Const SHIFTJIS_CHARSET = 128
Const HANGEUL_CHARSET = 129
Const CHINESEBIG5_CHARSET = 136
Const OEM_CHARSET = 255
'used with fdwOutputPrecision
Const OUT_CHARACTER_PRECIS = 2
Const OUT_DEFAULT_PRECIS = 0
Const OUT_DEVICE_PRECIS = 5
'used with fdwClipPrecision
Const CLIP_DEFAULT_PRECIS = 0
Const CLIP_CHARACTER_PRECIS = 1
Const CLIP_STROKE_PRECIS = 2
'used with fdwQuality
Const DEFAULT_QUALITY = 0
Const DRAFT_QUALITY = 1
Const PROOF_QUALITY = 2
'used with fdwPitchAndFamily
Const DEFAULT_PITCH = 0
Const FIXED_PITCH = 1
Const VARIABLE_PITCH = 2
'used with SetBkMode
Const OPAQUE = 2
Const TRANSPARENT = 1

Const PS_SOLID = 0
Const PS_DASH = 1
Const PS_DOT = 2
Const PS_DASHDOT = 3
Const PS_DASHDOTDOT = 4
Const PS_NULL = 5
Const PS_INSIDEFRAME = 6

Const ANSI_FIXED_FONT = 11  'Standard System Monospaced Font
Const ANSI_VAR_FONT = 12  'Standrad System Proportional breites Font
Const BLACK_BRUSH = 4  'Schwarzer Brush
Const BLACK_PEN = 7  'Schwarzer Pen
Const DEFAULT_GUI_FONT = 17  '(Win 9x) Standard Font fr Benutzerobjekte in Windows
Const DEFAULT_PALETTE = 15  'Standard Systempalette
Const DEVICE_DEFAULT_FONT = 14  '(Win NT) Standard Font des Devices
Const DKGRAY_BRUSH = 3  'Dunkel Grauer Brush
Const GRAY_BRUSH = 2  'Grauer Brush
Const LTGRAY_BRUSH = 1  'Hell Grauer Brush
Const NULL_BRUSH = 5  'Ein Unsichtbarer Brush, keine Farbe
Const NULL_PEN = 8  'Ein Unsichtbarer Pen, keine Farbe
Const OEM_FIXED_FONT = 10  'Original Equipment Manufacturer
Const SYSTEM_FIXED_FONT = 16  'System Monospaced Font unter Pre 3.x Versionen von Windows
Const SYSTEM_FONT = 13  'System Font
Const WHITE_BRUSH = 0  'Weisser Brush
Const WHITE_PEN = 6  'Weisser Pen


Const LOGPIXELSY = 90
Const COLOR_WINDOW = 5

Private Type POINTAPI
        X As Long
        y As Long
End Type
Private Type DOCINFO
        cbSize As Long
        lpszDocName As String
        lpszOutput As String
        lpszDatatype As String
        fwType As Long
End Type
Declare Function GetObject Lib "gdi32" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long
Private Declare Function PolyDraw Lib "gdi32" (ByVal hdc As Long, lppt As POINTAPI, lpbTypes As Byte, ByVal cCount As Long) As Long
Private Declare Function StartDoc Lib "gdi32" Alias "StartDocA" (ByVal hdc As Long, lpdi As DOCINFO) As Long
Private Declare Function StartPage Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function EndPage Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function EndDoc Lib "gdi32" (ByVal hdc As Long) As Long

Private Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal y As Long) As Long
Private Declare Function SetPixel Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal y As Long, ByVal crColor As Long) As Long

Private Declare Function PaintDesktop Lib "user32" (ByVal hdc As Long) As Long
Private Declare Function StretchBlt Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long
Private Declare Function GetBkColor Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function MoveToEx Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal y As Long, ByVal lpPoint As Any) As Long

Private Declare Function LineTo Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal y As Long) As Long

Private Declare Function GetActiveWindow Lib "user32" () As Long
Private Declare Function GetWindowDC Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function Ellipse Lib "gdi32" (ByVal hdc As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long

Private Declare Function TextOut Lib "gdi32" Alias "TextOutA" (ByVal hdc As Long, ByVal X As Long, ByVal y As Long, ByVal lpString As String, ByVal nCount As Long) As Long
Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long

Private Declare Function FloodFill Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal y As Long, ByVal crColor As Long) As Long

Private Declare Function CreateFontIndirect Lib "gdi32" Alias "CreateFontIndirectA" (lpLogFont As LOGFONT) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function GetDeviceCaps Lib "gdi32" (ByVal hdc As Long, ByVal nIndex As Long) As Long
Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal X As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hdc As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function GetDC Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function CreateEllipticRgn Lib "gdi32" (ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function SetWindowRgn Lib "user32" (ByVal hwnd As Long, ByVal hRgn As Long, ByVal bRedraw As Boolean) As Long
Private Declare Function CreateFont Lib "gdi32" Alias "CreateFontA" (ByVal nHeight As Long, ByVal nWidth As Long, ByVal nEscapement As Long, ByVal nOrientation As Long, ByVal fnWeight As Long, ByVal fdwItalic As Boolean, ByVal fdwUnderline As Boolean, ByVal fdwStrikeOut As Boolean, ByVal fdwCharSet As Long, ByVal fdwOutputPrecision As Long, ByVal fdwClipPrecision As Long, ByVal fdwQuality As Long, ByVal fdwPitchAndFamily As Long, ByVal lpszFace As String) As Long
Private Declare Function MulDiv Lib "kernel32" (ByVal nNumber As Long, ByVal nNumerator As Long, ByVal nDenominator As Long) As Long
Private Declare Function SetBkMode Lib "gdi32" (ByVal hdc As Long, ByVal nBkMode As Long) As Long
Private Declare Function GetSysColorBrush Lib "user32" (ByVal nIndex As Long) As Long
Declare Function GetStockObject Lib "gdi32" (ByVal nIndex As Long) As Long
Declare Function lstrcpy Lib "kernel32" Alias "lstrcpyA" (ByVal lpString1 As String, ByVal lpString2 As String) As Long
Declare Function CreatePen Lib "gdi32" (ByVal nPenStyle As Long, ByVal nWidth As Long, ByVal crColor As Long) As Long

Rem Private Declare Function wsprintf Lib "user32" (ByVal lpOut As Long, ByVal lpFmt As Long) As Long

Private Const LF_FACESIZE = 32
Private Type LOGFONT
    lfHeight As Long
    lfWidth As Long
    lfEscapement As Long
    lfOrientation As Long
    lfWeight As Long
    lfItalic As Byte
    lfUnderline As Byte
    lfStrikeOut As Byte
    lfCharSet As Byte
    lfOutPrecision As Byte
    lfClipPrecision As Byte
    lfQuality As Byte
    lfPitchAndFamily As Byte
    lfFaceName(LF_FACESIZE) As Byte
End Type

Public Const Barva_cerna = 0

Public Sub Tisk_List_Boxu()
Dim DI As DOCINFO
Dim hFont As Long
Dim hPen As Long
Dim struc_font As LOGFONT
Dim base_hDC As Long
Dim Souradnice_y As Integer
Dim a As Integer


DI.cbSize = Len(DI)
DI.lpszDocName = "FTDI EEPROM scanner"
DI.lpszOutput = vbNullString
DI.lpszDatatype = vbNullString

Rem get na default font

Let rnt = GetObject(GetStockObject(ANSI_FIXED_FONT), Len(struc_font), struc_font)

Rem Let rnt = GetObject(GetStockObject(DEFAULT_GUI_FONT), Len(struc_font), struc_font)
If rnt = 0 Then Exit Sub

Rem ziskani handle hdc
Let base_hDC = Printer.hdc
If base_hDC = 0 Then Exit Sub

Rem upraveni default fontu
struc_font.lfHeight = 40
struc_font.lfWidth = 25
struc_font.lfItalic = False
struc_font.lfWeight = 570
lstrcpy struc_font.lfFaceName, "Courier"

Rem vytvoreni noveho fontu dle struc_font
hFont = CreateFontIndirect(struc_font)
If hFont = 0 Then Exit Sub

Rem prirazeni noveho fontu do hDC
Let rnt = SelectObject(base_hDC, hFont)
Rem Let rnt = SelectObject(base_hDC, BM.LoggerList.h)
If rnt = 0 Then Exit Sub

Rem vytvoreni pera
hPen = CreatePen(PS_SOLID, 4, Barva_cerna)
If rnt = 0 Then Exit Sub

Let hPen = SelectObject(base_hDC, hPen)
If rnt = 0 Then Exit Sub

Call StartDoc(base_hDC, DI)
Rem prepare the printer driver to accept data
Call StartPage(base_hDC)
Rem hlavicka

If BM.LoggerList.ListCount > 0 Then
    For a = 0 To BM.LoggerList.ListCount - 1
        Let Souradnice_y = Souradnice_y + 35
        Let rnt = TextOut(base_hDC, 10, Souradnice_y, BM.LoggerList.List(a), Len(BM.LoggerList.List(a)))
    Next a
End If


Rem ukonceni stranky
Call EndPage(base_hDC)

Rem ukonceni dokumentu pro tisk
Call EndDoc(base_hDC)

DeleteObject (hPen)
DeleteObject (hFont)
End Sub
