Attribute VB_Name = "ftdi_read_eeprom"
' By HaCeSOFT
' Pavel Prochazka
' hacesoft@mujmail.cz
' www.prochazka.zde.cz
'
'
' DATE 30_12_2005.15:35
'
'
' TENTO SW je pro nekomercni ucely zdarma!!!

Public Function READ_eeprom()
Dim numDevs As Long
Dim sListDevices As String
Dim a As Long
Dim ftStatus As Long
Dim rnt As Long
Dim strManufacturer As String
Dim strManufacturerID As String
Dim strDescription As String
Dim strSerialNumber As String
Dim ftDevice As Long
Dim Jaky_FTDI_chip As Long

strManufacturer = String(42, Chr(0)) 'vynuluje retezec ...
strManufacturerID = String(42, Chr(0)) 'vynuluje retezec ...
strDescription = String(42, Chr(0)) 'vynuluje retezec ...
strSerialNumber = String(42, Chr(0)) 'vynuluje retezec ...

If BM.text_info.Value = 1 Then

    FT_GetNumDevices numDevs, vbNullString, FT_LIST_BY_NUMBER_ONLY
    If numDevs = 0 Then
        BM.LoggerList.AddItem "FTDI Device Not Find ..."
       Exit Function
    Else
        BM.LoggerList.AddItem "Number Device: " & numDevs
    End If
    
    For a = 0 To numDevs - 1
    sListDevices = String(255, Chr(0)) 'vynuluje retezec ...
    Let rnt = FT_ListDevices(a, sListDevices, FT_LIST_BY_INDEX Or FT_OPEN_BY_DESCRIPTION)
    If rnt = FT_OK Then
        BM.LoggerList.AddItem sListDevices
   Else
       BM.LoggerList.AddItem "FT_ListDevices failed --> " + FT_Status(FT_STATUS_())
    End If
    Next a
    BM.LoggerList.AddItem ""
    
    
    ftStatus = FT_EE_READ_()
    If ftStatus <> FT_OK Then
        BM.LoggerList.AddItem "FT_EE_READ failed --> " + FT_Status(FT_STATUS_())
        BM.LoggerList.AddItem "---------------------------------------------------------------------------------------------"
        BM.LoggerList.AddItem ""
        Exit Function
    End If
    
    
    rnt = FT_EE_UASize_()
    If rnt = -1 Then
        BM.LoggerList.AddItem "Read UASIZE Failed: code --> " + FT_Status(FT_STATUS_())
    Else
        BM.LoggerList.AddItem "UASIZE = " & str(rnt) & " bytes"
        If lngSize = 64 Then LoggerList.AddItem "EEPROM type 93C46" '93C46
        If lngSize = 128 Then LoggerList.AddItem "EEPROM type 93C56" '93C56
        If lngSize = 256 Then LoggerList.AddItem "EEPROM type 93C66" '93C66
    End If
    BM.LoggerList.AddItem ""
    
    Let rnt = GET_VendorId_()
    Let rnt = GET_Manufacturer_(strManufacturer)
    If rnt <> 0 Then Let strManufacturer = ""
    
    Let rnt = GET_ManufacturerId_(strManufacturerID)
    If rnt <> 0 Then Let strManufacturerID = ""
    
    Let rnt = GET_Description_(strDescription)
    If rnt <> 0 Then Let strDescription = ""
    
    Let rnt = GET_SerialNumber_(strSerialNumber)
    If rnt <> 0 Then Let strSerialNumber = ""

    Let Jaky_FTDI_chip = FT_GetFTDevice_()
    'Display results:
    BM.LoggerList.AddItem "Manufacturer       : " & strManufacturer
    BM.LoggerList.AddItem "ManufacturerID     : " & strManufacturerID
    BM.LoggerList.AddItem "Description        : " & strDescription
    BM.LoggerList.AddItem "Serialnumber       : " & strSerialNumber
    BM.LoggerList.AddItem "VendorID           : " & "0x" & Format(Int_To_XX(GET_VendorId_(), 16), "0000")
    BM.LoggerList.AddItem "ProductID          : " & "0x" & Format(Int_To_XX(GET_ProductId_(), 16), "0000")
    BM.LoggerList.AddItem "Max Power          : " & GET_MaxPower_() & "mA  (0 < MaxPower <= 500)"
    BM.LoggerList.AddItem "Plug-and-Play      : " & GET_PnP_() & "  (0 = disabled, 1 = enabled)"
    BM.LoggerList.AddItem "Self-Powered       : " & GET_SelfPowered_() & "  (0 = bus powered, 1 = self powered)"
    BM.LoggerList.AddItem "RemoteWakeup       : " & GET_RemoteWakeup_() & "  (0 = not capable, 1 = capable)"
    BM.LoggerList.AddItem "IsoIn              : " & GET_IsoIn_() & "  (true if in endpoint is isochronous)"
    BM.LoggerList.AddItem "IsoOut             : " & GET_IsoOut_() & "  (true if out endpoint is isochronous)"
    BM.LoggerList.AddItem ""
    
    If Jaky_FTDI_chip = FT_DEVICE_BM Then
        BM.LoggerList.AddItem "FTU2xxxBM extensions"
        BM.LoggerList.AddItem "Rev4               : " & GET_Rev4_() & "  (true if Rev4 chip, false otherwise)"
        BM.LoggerList.AddItem "PullDownEnable     : " & GET_PullDownEnable_() & "  (true if pull down enabled)"
        BM.LoggerList.AddItem "SerNumEnable       : " & GET_SerNumEnable_()
        BM.LoggerList.AddItem "USBVersionEnable   : " & GET_USBVersionEnable_() & "  (true if chip uses USBVersion)"
        BM.LoggerList.AddItem "USBVersion         : " & "0x" & Format(Int_To_XX(GET_USBVersion_(), 16), "0000") & "  (0x0200 => USB2)"
        BM.LoggerList.AddItem ""
    End If
    
    If Jaky_FTDI_chip = FT_DEVICE_2232C Then
        BM.LoggerList.AddItem "FT2232C extensions"
        BM.LoggerList.AddItem "Rev5               : " & GET_Rev5_() & "  non-zero if Rev5 chip, zero otherwise"
        BM.LoggerList.AddItem "PullDownEnable5    : " & GET_PullDownEnable5_() & "  non-zero if pull down enabled"
        BM.LoggerList.AddItem "SerNumEnable5      : " & GET_SerNumEnable5_() & "  non-zero if serial number to be used"
        BM.LoggerList.AddItem "USBVersionEnable5  : " & GET_USBVersionEnable5_() & "  non-zero if chip uses USBVersion"
        BM.LoggerList.AddItem "USBVersion5        : " & "0x" & Format(Int_To_XX(GET_USBVersion5_(), 16), "0000") & "  0x0200 => USB2)"
        BM.LoggerList.AddItem ""
        BM.LoggerList.AddItem "IsoInA             : " & GET_IsoInA_() & "  non-zero if in endpoint is isochronous"
        BM.LoggerList.AddItem "IsoOutA            : " & GET_IsoOutA_() & "  non-zero if out endpoint is isochronous"
        BM.LoggerList.AddItem "AlsHighCurrent     : " & GET_AIsHighCurrent_() & "  non-zero if interface is high current"
        BM.LoggerList.AddItem "IFAlsFifo          : " & GET_IFAIsFifo_() & "  non-zero if interface is 245 FIFO"
        BM.LoggerList.AddItem "IFAlsFifoTar       : " & GET_IFAIsFifoTar_() & "  non-zero if interface is 245 FIFO CPU target"
        BM.LoggerList.AddItem "IFAlsFastSer       : " & GET_IFAIsFastSer_() & "  non-zero if interface is Fast serial"
        BM.LoggerList.AddItem "AlsVCP             : " & GET_AIsVCP_() & "  non-zero if interface is to use VCP drivers"
        BM.LoggerList.AddItem ""
        BM.LoggerList.AddItem "IsoInB             : " & GET_IsoInB_() & "  non-zero if in endpoint is isochronous"
        BM.LoggerList.AddItem "IsoOutB            : " & GET_IsoOutB_() & "  non-zero if out endpoint is isochronous"
        BM.LoggerList.AddItem "BlsHighCurrent     : " & GET_BIsHighCurrent_() & "  non-zero if interface is high current"
        BM.LoggerList.AddItem "IFBlsFifo          : " & GET_IFBIsFifo_() & "  non-zero if interface is 245 FIFO"
        BM.LoggerList.AddItem "IFBlsFifoTar       : " & GET_IFBIsFifoTar_() & "  non-zero if interface is 245 FIFO CPU target"
        BM.LoggerList.AddItem "IFBlsFastSer       : " & GET_IFBIsFastSer_() & "  non-zero if interface is Fast serial"
        BM.LoggerList.AddItem "BlsVCP             : " & GET_BIsVCP_() & "  non-zero if interface is to use VCP drivers"
        BM.LoggerList.AddItem ""
    End If
    
    If Jaky_FTDI_chip = FT_DEVICE_232R Then
        BM.LoggerList.AddItem "FT232R extensions"
        BM.LoggerList.AddItem "NOT IMPLEMENT"
        BM.LoggerList.AddItem ""
    End If
End If

READ_memory_eepromky

Rem ukonceni vypisu
BM.LoggerList.AddItem ""
BM.LoggerList.AddItem "**********************************************************************************************"

End Function

Public Function Jaky_CHIP() As Long

Dim ftDevice As Long
Dim deviceID As Long
Dim SerialNumber As String
Dim Description As String
Dim rnt As Long

Let deviceID = 0
Let SerialNumber = String(255, Chr(20)) + Chr(0)
Let Description = String(255, Chr(20)) + Chr(0)

Let rnt = FT_GetDeviceInfo_(SerialNumber, Description)
Let ftDevice = FT_GetFTDevice_()
Let deviceID = FT_GetDeviceID_()

Jaky_CHIP = ftDevice
BM.LoggerList.AddItem "deviceID " & deviceID
If (rnt = 0) Then
Select Case ftDevice
    Case FT_DEVICE_2232C
        ' device is FT2232C
        BM.LoggerList.AddItem "Device FT2232C ..."
    Case FT_DEVICE_BM
        ' device is FTU232BM
        BM.LoggerList.AddItem "Device FTU232BM ..."
    Case FT_DEVICE_AM
        ' device is FT8U232AM
        BM.LoggerList.AddItem "Device FT8U232AM ..."
    Case FT_DEVICE_100AX
        'device is FT8U100AX
        BM.LoggerList.AddItem "Device FT8U100AX ..."
    Case FT_DEVICE_UNKNOWN
        'device is UNKNOWN
        BM.LoggerList.AddItem "FTDI Device UNKNOWN ..."
        BM.LoggerList.AddItem "Description : " & Description
        BM.LoggerList.AddItem "SerialNumber : " & SerialNumber
    Case FT_DEVICE_232R
        'device is FT232R
        BM.LoggerList.AddItem "Device FT_DEVICE_232R ..."
    Case Else
        'unknown device (this should not happen!)
        'deviceID contains encoded device ID
        'SerialNumber, Description contain 0-terminated strings
        BM.LoggerList.AddItem "Device Unknown ..."
    End Select
Else
    BM.LoggerList.AddItem "FT_GetDeviceType Failed --> " + FT_Status(FT_STATUS_())
    Jaky_CHIP = -1
End If
End Function

Public Function Jaky_CHIP_Value() As Long

Dim ftDevice As Long
Dim deviceID As Long
Dim SerialNumber As String
Dim Description As String
Dim rnt As Long

Let deviceID = 0
Let SerialNumber = String(255, Chr(20)) + Chr(0)
Let Description = String(255, Chr(20)) + Chr(0)

Let rnt = FT_GetDeviceInfo_(SerialNumber, Description)
Let ftDevice = FT_GetFTDevice_()
Let deviceID = FT_GetDeviceID_()

Jaky_CHIP_Value = ftDevice
End Function
